diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/http.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/http.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/http.php	2013-06-21 01:12:17.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/http.php	2013-07-31 01:46:02.000000000 -0500
***************
*** 29,34 ****
--- 29,118 ----
  }
  
  /**
+  * Retrieve the raw response from a safe HTTP request.
+  *
+  * This function is ideal when the HTTP request is being made to an arbitrary
+  * URL. The URL is validated to avoid redirection and request forgery attacks.
+  *
+  * @see wp_remote_request() For more information on the response array format
+  * 	and default arguments.
+  *
+  * @since 3.6.0
+  *
+  * @param string $url Site URL to retrieve.
+  * @param array $args Optional. Override the defaults.
+  * @return WP_Error|array The response or WP_Error on failure.
+  */
+ function wp_safe_remote_request( $url, $args = array() ) {
+ 	$args['reject_unsafe_urls'] = true;
+ 	$http = _wp_http_get_object();
+ 	return $http->request( $url, $args );
+ }
+ 
+ /**
+  * Retrieve the raw response from a safe HTTP request using the GET method.
+  *
+  * This function is ideal when the HTTP request is being made to an arbitrary
+  * URL. The URL is validated to avoid redirection and request forgery attacks.
+  *
+  * @see wp_remote_request() For more information on the response array format
+  * 	and default arguments.
+  *
+  * @since 3.6.0
+  *
+  * @param string $url Site URL to retrieve.
+  * @param array $args Optional. Override the defaults.
+  * @return WP_Error|array The response or WP_Error on failure.
+  */
+ function wp_safe_remote_get( $url, $args = array() ) {
+ 	$args['reject_unsafe_urls'] = true;
+ 	$http = _wp_http_get_object();
+ 	return $http->get( $url, $args );
+ }
+ 
+ /**
+  * Retrieve the raw response from a safe HTTP request using the POST method.
+  *
+  * This function is ideal when the HTTP request is being made to an arbitrary
+  * URL. The URL is validated to avoid redirection and request forgery attacks.
+  *
+  * @see wp_remote_request() For more information on the response array format
+  * 	and default arguments.
+  *
+  * @since 3.6.0
+  *
+  * @param string $url Site URL to retrieve.
+  * @param array $args Optional. Override the defaults.
+  * @return WP_Error|array The response or WP_Error on failure.
+  */
+ function wp_safe_remote_post( $url, $args = array() ) {
+ 	$args['reject_unsafe_urls'] = true;
+ 	$http = _wp_http_get_object();
+ 	return $http->post( $url, $args );
+ }
+ 
+ /**
+  * Retrieve the raw response from a safe HTTP request using the HEAD method.
+  *
+  * This function is ideal when the HTTP request is being made to an arbitrary
+  * URL. The URL is validated to avoid redirection and request forgery attacks.
+  *
+  * @see wp_remote_request() For more information on the response array format
+  * 	and default arguments.
+  *
+  * @since 3.6.0
+  *
+  * @param string $url Site URL to retrieve.
+  * @param array $args Optional. Override the defaults.
+  * @return WP_Error|array The response or WP_Error on failure.
+  */
+ function wp_safe_remote_head( $url, $args = array() ) {
+ 	$args['reject_unsafe_urls'] = true;
+ 	$http = _wp_http_get_object();
+ 	return $http->head( $url, $args );
+ }
+ 
+ /**
   * Retrieve the raw response from the HTTP request.
   *
   * The array structure is a little complex.
***************
*** 49,54 ****
--- 133,157 ----
   * This function is called first to make the request and there are other API
   * functions to abstract out the above convoluted setup.
   *
+  * List of default arguments:
+  * 'method'      => 'GET'
+  *  - Default 'GET'  for wp_remote_get()
+  *  - Default 'POST' for wp_remote_post()
+  *  - Default 'HEAD' for wp_remote_head()
+  * 'timeout'     => 5
+  * 'redirection' => 5
+  * 'httpversion' => '1.0'
+  * 'user-agent'  => 'WordPress/' . $wp_version . '; ' . get_bloginfo( 'url' )
+  * 'blocking'    => true
+  * 'headers'     => array()
+  * 'cookies'     => array()
+  * 'body'        => null
+  * 'compress'    => false,
+  * 'decompress'  => true,
+  * 'sslverify'   => true,
+  * 'stream'      => false,
+  * 'filename'    => null
+  *
   * @since 2.7.0
   *
   * @param string $url Site URL to retrieve.
***************
*** 63,69 ****
  /**
   * Retrieve the raw response from the HTTP request using the GET method.
   *
!  * @see wp_remote_request() For more information on the response array format.
   *
   * @since 2.7.0
   *
--- 166,172 ----
  /**
   * Retrieve the raw response from the HTTP request using the GET method.
   *
!  * @see wp_remote_request() For more information on the response array format and default arguments.
   *
   * @since 2.7.0
   *
***************
*** 79,85 ****
  /**
   * Retrieve the raw response from the HTTP request using the POST method.
   *
!  * @see wp_remote_request() For more information on the response array format.
   *
   * @since 2.7.0
   *
--- 182,188 ----
  /**
   * Retrieve the raw response from the HTTP request using the POST method.
   *
!  * @see wp_remote_request() For more information on the response array format and default arguments.
   *
   * @since 2.7.0
   *
***************
*** 95,101 ****
  /**
   * Retrieve the raw response from the HTTP request using the HEAD method.
   *
!  * @see wp_remote_request() For more information on the response array format.
   *
   * @since 2.7.0
   *
--- 198,204 ----
  /**
   * Retrieve the raw response from the HTTP request using the HEAD method.
   *
!  * @see wp_remote_request() For more information on the response array format and default arguments.
   *
   * @since 2.7.0
   *
***************
*** 320,331 ****
   * @return mixed URL or false on failure.
   */
  function wp_http_validate_url( $url ) {
! 	$url = esc_url_raw( $url, array( 'http', 'https' ) );
  	if ( ! $url )
  		return false;
  
  	$parsed_url = @parse_url( $url );
! 	if ( ! $parsed_url )
  		return false;
  
  	if ( isset( $parsed_url['user'] ) || isset( $parsed_url['pass'] ) )
--- 423,434 ----
   * @return mixed URL or false on failure.
   */
  function wp_http_validate_url( $url ) {
! 	$url = wp_kses_bad_protocol( $url, array( 'http', 'https' ) );
  	if ( ! $url )
  		return false;
  
  	$parsed_url = @parse_url( $url );
! 	if ( ! $parsed_url || empty( $parsed_url['host'] ) )
  		return false;
  
  	if ( isset( $parsed_url['user'] ) || isset( $parsed_url['pass'] ) )
***************
*** 348,362 ****
  				$ip = false;
  		}
  		if ( $ip ) {
- 			if ( '127.0.0.1' === $ip )
- 				return false;
  			$parts = array_map( 'intval', explode( '.', $ip ) );
! 			if ( 10 === $parts[0] )
! 				return false;
! 			if ( 172 === $parts[0] && 16 <= $parts[1] && 31 >= $parts[1] )
! 				return false;
! 			if ( 192 === $parts[0] && 168 === $parts[1] )
! 				return false;
  		}
  	}
  
--- 451,466 ----
  				$ip = false;
  		}
  		if ( $ip ) {
  			$parts = array_map( 'intval', explode( '.', $ip ) );
! 			if ( '127.0.0.1' === $ip
! 				|| ( 10 === $parts[0] )
! 				|| ( 172 === $parts[0] && 16 <= $parts[1] && 31 >= $parts[1] )
! 				|| ( 192 === $parts[0] && 168 === $parts[1] )
! 			) {
! 				// If host appears local, reject unless specifically allowed.
! 				if ( ! apply_filters( 'http_request_host_is_external', false, $host, $url ) )
! 					return false;
! 			}
  		}
  	}
  
***************
*** 372,374 ****
--- 476,519 ----
  
  	return false;
  }
+ 
+ /**
+  * Whitelists allowed redirect hosts for safe HTTP requests as well.
+  *
+  * Attached to the http_request_host_is_external filter.
+  *
+  * @since 3.6.0
+  *
+  * @param bool $is_external
+  * @param string $host
+  * @return bool
+  */
+ function allowed_http_request_hosts( $is_external, $host ) {
+ 	if ( ! $is_external && wp_validate_redirect( 'http://' . $host ) )
+ 		$is_external = true;
+ 	return $is_external;
+ }
+ 
+ /**
+  * Whitelists any domain in a multisite installation for safe HTTP requests.
+  *
+  * Attached to the http_request_host_is_external filter.
+  *
+  * @since 3.6.0
+  *
+  * @param bool $is_external
+  * @param string $host
+  * @return bool
+  */
+ function ms_allowed_http_request_hosts( $is_external, $host ) {
+ 	global $wpdb, $current_site;
+ 	static $queried = array();
+ 	if ( $is_external )
+ 		return $is_external;
+ 	if ( $host === $current_site->domain )
+ 		return true;
+ 	if ( isset( $queried[ $host ] ) )
+ 		return $queried[ $host ];
+ 	$queried[ $host ] = (bool) $wpdb->get_var( $wpdb->prepare( "SELECT domain FROM $wpdb->blogs WHERE domain = %s LIMIT 1", $host ) );
+ 	return $queried[ $host ];
+ }
